import math

# Programme fait le 10 août 2015 par Denis  : Uncle Den's
# http://uncledens.chez-alice.fr/
# Vous pouvez le contacter sur uncledens(arobase)yahoo(point)fr
# Remplacer (arobase) par "@" sans les guillemets
# et (point) par "." sans les guillemets
# Si je ne réponds pas (je ne consulte pas ma messagerie yahoo tous les jours)  
# contactez moi via Geneanet, mon pseudo: uncledens


#  ========== ENTREE SORTIE du programme ===========
# en entrée : le GEDCOM
# en sortie :  le fichier SVG qui pourra ere visualisé sous Firefox,
# et modifié sous Inkscape qui pourra être modifié et pourra générer le PDF à imprimer
entree=open("ged.ged" , "r" , encoding="iso8859_15")
destination = open("arbre_circ.svg", "w")

# ---arccercle dessine l'arc de cercle de la cellule autour de l'individu
# cet arc de cercle peut servir de support au texte provenant de la généalogie:
# nom, prénom, Date et lieu de naissance et de mort
def arcercle(x1,y1,x2,y2,xc,yc,aspect): 
    global chaine,text,couleur,epaisseur,numchem
    r1=math.sqrt((x1-xc)*(x1-xc)+(y1-yc)*(y1-yc))
    r2=math.sqrt((x2-xc)*(x2-xc)+(y2-yc)*(y2-yc))
    #verif que les rayons sont de tailles similaires
    if (math.sqrt((r1-r2)*(r1-r2))/(r1+r2))>0.01: #erreur de 1%
        print("Les rayons ne sont pas les memes, à modifier")
        #math.acos() arc cosinus
    angle=math.acos(((x1-xc)*(x2-xc)/(r1*r2))+((y1-yc)*(y2-yc)/(r1*r2)))
    if (x1-xc)==0:
        anglebase=math.pi/2
    else:
        anglebase=math.atan((y1-yc)/(x1-xc))
    base=x1-xc
    ex=1
    if x1<xc:
        ex=-1
    if angle<0.6 :#radiants
        # id="textpath" pour que le texte puisse suivre le chemin
        #coordonnées de Q
        rq=r1/math.cos(angle/2)

        xq=xc+ex*rq*math.cos(anglebase+(angle/2))
        yq=yc+ex*rq*math.sin(anglebase+(angle/2))  
        # <path d="M x1 y1 Q cq cq x2 y2"/> : Courbe de Bézier quadratique
        numchem+=1
        chaine+="<path id=\"chem"+str(numchem)+"\" d=\"M "+" "+str(x1)+" "+str(y1)
        chaine+=" Q "+str(int(xq))+" "+str("%.2f" % yq)+" "+str(x2)+" "+str(y2)+"\""
        if aspect==1:
            chaine+=" style=\"fill:none;stroke:"+couleur+";\" stroke-width=\""+epaisseur+"\"/>\n"
        else:
            chaine+=" style=\"fill:none;stroke:none;\" />\n"
        
    elif angle<1.6:#radiants
        #Courbe de Bézier quadratique avec partage de point de contrôle
        #courbe passant par les trois points 1,int et 2
        #<path d="M x1 y1 Q cq cq xint yint T x2 y2"/>
        #1 et 2 points extremes
        #int point intermediaire
        #cq, cq c'est Q situé entre 1 et int
        #calcul des coordonneés du point intermediaire, c'est à R1 de C, et à angle/2 de 1 et 3
        xint=xc+ex*r1*math.cos(anglebase+(angle/2))
        yint=yc+ex*r1*math.sin(anglebase+(angle/2))
        #il faut definir les coordonnées de Q
        rq=r1/math.cos(angle/4)  # sur 4 car on a deja pris la moitier pour le point intermediaire
        xq=xc+ex*rq*math.cos(anglebase+(angle/4))
        yq=yc+ex*rq*math.sin(anglebase+(angle/4))
        numchem+=1
        chaine+="<path id=\"chem"+str(numchem)+"\" d=\"M "+" "+str(x1)+" "+str(y1)
        chaine+=" Q "+str("%.2f" % xq)+" "+str("%.2f" % yq)+" "+str("%.2f" % xint)+" "
        chaine+=str("%.2f" % yint)+" T "+str(x2)+" "+str(y2)+"\""
        if aspect==1:
            chaine+=" style=\"fill:none;stroke:"+couleur+";\" stroke-width=\""+epaisseur+"\"/>\n"
        else:
            chaine+=" style=\"fill:none;stroke:none;\" />\n"
        
    else:# si il faut dessiner qch proche d'un demi-cercle, la courbe de Bézier fonctionne mal, on coupe le probleme en deux
        #calcul d'un point intermédiaire, et decoupage de l'arc de cercle en 2 parties
        xint=xc+ex*r1*math.cos(anglebase+(angle/2.1)) # 2.1 et pas 2 sinon  
        yint=yc+ex*r1*math.sin(anglebase+(angle/2.1)) # erreur :division par zero
        arcercle(x1,y1,xint,yint,xc,yc,aspect)# trace la premiere partie
        arcercle(xint,yint,x2,y2,xc,yc,aspect)#trace la seconde partie

#--- Fin arcercle

def trait(x1,y1,x2,y2,aspect):
    global chaine,epaisseur,couleur,numchem
    numchem+=1
    chaine+="<line id=\"chem"+str(numchem)+"\" "
    chaine+="x1=\""+str(x1)+"\" x2=\""+str(x2)+"\" y1=\""+str(y1)+"\" y2=\""+str(y2)+"\""
    if aspect==1:
        chaine+=" style=\"fill:none;stroke:"+couleur+";\" stroke-width=\""+epaisseur+"\"/>\n"
    else:
        chaine+=" style=\"fill:none;stroke:none;\" />\n"
    return

          
def tracecell(r1,r2,angle1,angle2):
    global xc,yc,delta,rangle,epaisseur, couleur,numchem # + options graphiques: stroke, blue black...
    r12=r2-delta-rangle
    r34=r1+delta+rangle
    theta=angle1+(delta+rangle)/r12 # developpement limité de atan(theta)=theta pour theta petit
    xc1=xc-r12*math.cos(theta)
    yc1=yc-r12*math.sin(theta)
    theta=angle1+(delta)/r12
    x1=xc-r12*math.cos(theta)
    y1=yc-r12*math.sin(theta)
    theta=angle1+(delta+rangle)/(r2-delta)
    x2=xc-(r2-delta)*math.cos(theta)
    y2=yc-(r2-delta)*math.sin(theta)

    theta=angle2-(delta+rangle)/r12
    xc2=xc-r12*math.cos(theta)
    yc2=yc-r12*math.sin(theta)
    theta=angle2-(delta+rangle)/(r2-delta)
    x3=xc-(r2-delta)*math.cos(theta)
    y3=yc-(r2-delta)*math.sin(theta) 
    theta=angle2-(delta)/r12
    x4=xc-r12*math.cos(theta)
    y4=yc-r12*math.sin(theta)

    theta=angle2-(delta+rangle)/r34 # developpement limité de atan(theta)=theta pour theta petit
    xc3=xc-r34*math.cos(theta)
    yc3=yc-r34*math.sin(theta)
    theta=angle2-(delta)/r34
    x5=xc-r34*math.cos(theta)
    y5=yc-r34*math.sin(theta)
    theta=angle2-(delta+rangle)/(r1+delta)
    x6=xc-(r1+delta)*math.cos(theta)
    y6=yc-(r1+delta)*math.sin(theta)

    theta=angle1+(delta+rangle)/r34
    xc4=xc-r34*math.cos(theta)
    yc4=yc-r34*math.sin(theta)
    theta=angle1+(delta+rangle)/(r1+delta)
    x7=xc-(r1+delta)*math.cos(theta)
    y7=yc-(r1+delta)*math.sin(theta) 
    theta=angle1+(delta)/r34
    x8=xc-r34*math.cos(theta)
    y8=yc-r34*math.sin(theta)

    arcercle(x1,y1,x2,y2,xc1,yc1,1)
    arcercle(x2,y2,x3,y3,xc,yc,1)#
    
    arcercle(x3,y3,x4,y4,xc2,yc2,1)
    trait(x4,y4,x5,y5,1)#
    
    arcercle(x5,y5,x6,y6,xc3,yc3,1)
    arcercle(x7,y7,x8,y8,xc4,yc4,1)
    arcercle(x7,y7,x6,y6,xc,yc,1)#
    trait(x1,y1,x8,y8,1)#
    return

# --- convertit les caracteres spéciaux vers XML
def nettoietxt(texte): # 
    b=str(texte.encode('ascii', 'xmlcharrefreplace'))
    texte=b[2:len(b)-1]
    return texte

# --- change les abréviations du Gedcom.  ex: "ABT" (about = environ) => "~"
def rempldate(ligne):
    mois = [' ','ABT','BEF','AFT','Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov','Dec']
    num = ['','~','<','>','/01/', '/02/', '/03/', '/04/', '/05/', '/06/', '/07/', '/08/', '/09/', '/10/', '/11/', '/12/']
    i = 0
    while i < len(mois):
        ligne = ligne.replace(mois[i], num[i])
        i += 1
    return ligne
#--- fin rempldate

#--- renvoi le nombre de la ligne du GEDCOM compris entre 2 "@"
def numero(mot):
    po=mot.index("@")
    num=str(mot[0:po])
    return num
# --- fin numero

# --- routine récursive qui renvoie les parents de l'individu demandé                 
def sosaparent(nsosa,i):
    global sosa,pere,mere,maxsosa
    if (2*nsosa)<maxsosa:
        if mere[i]=="":
            mere[i]=0
        if pere[i]=="":
            pere[i]=0
        sosa[2*nsosa]=int(pere[i])
        sosa[2*nsosa+1]=int(mere[i])
        sosaparent(2*nsosa,int(pere[i]))
        sosaparent(2*nsosa+1,int(mere[i]))
    return
# fin routine récursive qui renvoie le numéro des parents de l'indiv       

#Initialisation des données    
#===== GEDCOM =======
indi=[0]
sour=[0]
fami=[0]
husb=[0]
wife=[0]
chil=[0]
pere=[0]
mere=[0]
famc=[0]
fams=[0]
nindi=0
nsour=0
nfami=0

ffami=0
fsour=0

numchem=10000

# ================= Interface utilisateur 1=============================
print("Quel est le nombre de générations que vous voulez faire apparaitre dans votre arbre ?")
print("-minimum 2 (l\'individu central et ses parents")
print("-maximum 12 (au delà de 10, c\'est déconseillé: arbre illisible et programme lent)")
print("-conseillé: entre 4 et 6")
nbgeneration=int(input())
print(" ")
# ======================================================================


#initialisation du tableau des SOSA:
maxsosa=pow(2,nbgeneration)
sosa=[]
i=1
while i<(maxsosa+1):
    sosa.append(0)
    i+=1

# ======= GRAPHIQUE ======
couleur="black"  #Couleur et épaiseur du trait du cadre
epaisseur="1"

delta=2 #petit écart entre les cellules des cases de l'arbre circulaire
rangle=5 # rayon de l'arrondi aux coins des cellules de l'arbre circulaire

# détermination des rayons des des cercles de l'arbre circulaire
# generation1  => Rayon[1]=50 est le rayon du cercle central  ATTENTION ce n'est pas generation0 au centre
rayon=[0] 
rayon.append(50) # j'attribue la valeur 50 au premier cercle... A ajuster au besoin
i=1
while i!=(nbgeneration+1):
    r=math.sqrt(pow(2,i)*pow(rayon[1],2)+pow(rayon[i],2))
    i+=1
    rayon.append(int(r+0.5))
# Fin determination des rayons

#La taille du graphique fait 2*rayon[nbgeneration]+2, et le centre xc,xy est au milieu
xc=rayon[nbgeneration]+1
yc=rayon[nbgeneration]+1

# ===== Format d'écriture du texte =====
tailletitre1=8
interligne1=tailletitre1/3
tailletitre2=tailletitre1*0.7
interligne2=tailletitre2/3

couleurtexte="blue"
police="Verdana"
titre1="<text font-family=\""+police+"\" font-size=\""+str(tailletitre1)+"\" fill=\""+couleurtexte+"\" >"
titre1centre="<text text-anchor=\"middle\" font-family=\""+police+"\" font-size=\""+str(tailletitre1)+"\" fill=\""+couleurtexte+"\" >"
titre2="<text font-family=\""+police+"\" font-size=\""+str(tailletitre2)+"\" fill=\""+couleurtexte+"\" >"
titre2centre="<text text-anchor=\"middle\" font-family=\""+police+"\" font-size=\""+str(tailletitre2)+"\" fill=\""+couleurtexte+"\" >"
# exemple de texte
#

# entete du fichier SVG qui sera créé (cf destination)
entete="<?xml version=\"1.0\" standalone=\"no\"?>\n"
entete+="<svg width=\""+str(2*rayon[nbgeneration]+2)+"\" height=\""+str(2*rayon[nbgeneration]+2)+"\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\">\n"
chaine=entete
text="\" stroke=\"blue\" fill=\"none\" />\n"

#+++++++++++++++++++++++++++++++++++++++++++
#======== DEBUT DE LECTURE DU GEDCOM =======
#+++++++++++++++++++++++++++++++++++++++++++
for ligne in entree:
    mot=str(ligne)
    mot=mot.replace("\n","")
    long=len(mot)-1
    i=0
    code=""
    while i<long:
        code+=mot[i+1]
        i+=2
    mot=code
    if mot!="":
        if mot[0:4]=="0 @S":
            if mot[0:6]!= "0 @SUB":
                fsour=1
                ffami=2
                sour.append("")
                long=len(mot)
                ot=mot[4:long]
                pos=ot.index("@")+4
                nb=int(str(mot[4:pos]))
                while nsour!=nb: #précaution si un numéro de source n'existe pas
                    nsour+=1
                    sour.append("")
        elif mot[0:4]=="0 @F":
            ffami=1
            fami.append("")
            husb.append("")
            wife.append("")
            chil.append("")
            long=len(mot)
            ot=mot[4:long]
            pos=ot.index("@")+4
            nb=int(str(mot[4:pos]))
            while nfami!=nb: #précaution si un numéro de famille n'existe pas
                nfami+=1
                fami.append("")
                husb.append("")
                wife.append("")
                chil.append("")
        elif mot[0:4]=="0 @I":
            indi.append("")
            pere.append(0)
            mere.append(0)
            famc.append(0)
            fams.append(0) 
            long=len(mot)
            ot=mot[4:long]
            pos=ot.index("@")+4
            nb=int(str(mot[4:pos]))
            while nindi!=nb: #précaution si un numéro d'individu n'existe pas
                nindi+=1
                indi.append("")
                pere.append(0)
                mere.append(0)
                famc.append(0)
                fams.append(0)             
        elif mot[0:7]=="1 NAME ":
            indi[nindi]=str(indi[nindi])+"@"+str(mot[7:len(mot)])
        elif mot[0:6]=="1 BIRT":
            indi[nindi]=str(indi[nindi])+"\n"+"o"
        elif mot[0:5]=="1 CHR":
            indi[nindi]=str(indi[nindi])+"\n"+"b"
        elif mot[0:6]=="1 DEAT":
            indi[nindi]=str(indi[nindi])+"\n"+"+"
        elif mot[0:6]=="1 BURI":
            indi[nindi]=str(indi[nindi])+"\n"+"%"
        elif mot[0:6]=="1 CHAN":
            indi[nindi]=str(indi[nindi])+"\n"+"n"
        elif mot[0:6]=="2 DATE":# doit lire la date et attribuer à individu, famille ou source
            date=mot[6:len(mot)]
            date=rempldate(date)
            if fsour==1:
                sour[nsour]=sour[nsour]+date
            elif ffami==1:
                fami[nfami]=fami[nfami]+date
            else :
                indi[nindi]=indi[nindi]+date
            
        elif mot[0:6]=="2 PLAC":# doit lire la date et attribuer à individu, famille ou source
            place=mot[6:len(mot)]
            #date=rempldate(date) faut il faire des modifications dans les lieux?
            if fsour==1:
                sour[nsour]=sour[nsour]+place
            elif ffami==1:
                fami[nfami]=fami[nfami]+place
            else :
                indi[nindi]=indi[nindi]+place      
        elif mot[0:6]=="1 HUSB":# doit lire la date et attribuer à individu, famille ou source
            husb[nfami]=numero(mot[9:len(mot)])
        elif mot[0:6]=="1 WIFE":# doit lire la date et attribuer à individu, famille ou source
            wife[nfami]=numero(mot[9:len(mot)])
        elif mot[0:6]=="1 CHIL":# doit lire la date et attribuer à individu, famille ou source
            chil[nfami]+=numero(mot[9:len(mot)])+"\n"    
        elif mot[0:6]=="1 FAMC":# determine la famille de l'individu: permettra de connaitre le pere et la mere
            famc[nindi]=numero(mot[9:len(mot)])
        # FAMS + MARR(les conjoits = mariages) n'ont pas été interprété dans ce programme (à ajouter eventuellement)
        # les SOURCES non plua

# ++++++++++++++++++++++++++++++++++++++
# ==== FIN  DE LECTURE DU GEDCOM =======
# ++++++++++++++++++++++++++++++++++++++

# ===============Attibution des parents à chaque individu==============
# => l'indi[i] a son pere[i] et sa mere[i]  (le même "[i]") 
i=0
while i<nindi:
    i+=1
    if famc[i]!="":
        pere[i]=husb[int(famc[i])]
        mere[i]=wife[int(famc[i])]
# ========== Fin d'attibution des parents à chaque individu ==========

# EXEMPLE POUR VERIFIER avec l'individu 63, on l'affiche ainsi que son pere et sa mere
#i=63
#print("Parents de ",indi[i])
#print("père:",pere[i],indi[int(pere[i])])
#print("mère:",mere[i],indi[int(mere[i])])
# FIN EXEMPLE



# ==========================================================
# ===== Application à un individu (ici le 66) ==============
# ===== Ellaboration de son arbre,
# ===== en déterminant ses SOSA qui découlent de lui =======
# ==>Ulterieurement, mattre un input sur le "66"   =========
# ==========================================================

# determination des sosa utiles à la création de l'arbre
# on pourra alors interroger les SOSA[i], ou plutot indi[int(sosa[i])]


# ================= Interface utilisateur 2=============================


validation="n"
while validation=="n":
    print("Quel est le numéro de l'individu que vous voulez voir au centre de l'arbre ?")
    print("(ce numéro est indiqué dans votre logiciel de généalogie)")
    choix=int(input())
    sosa[1]=choix
    print("Est-ce bien cet individu ? oui (o) / non (n)")
    print(" => ",indi[int(sosa[1])],"\n")
    validation=input()
    while (validation!="o")and(validation!="n"):
        print("Je n\'aipas compris votre réponse.\nTapez sur la lettre \"o\" (oui) ou \"n\" (non) de votre clavier")
        validation=input()

sosaparent(1,sosa[1])
print(" => \n",indi[int(sosa[1])])


# ========================================================
#
#        GRAPHIQUE
#
# ========================================================

# ========= CERCLE CENTRAL =================
numchem+=1
chaine+="\n<circle id=\"chem"+str(numchem)+"\" "
chaine+="cx=\""+str(xc)+"\" cy=\""+str(yc)+"\" r=\""+str(rayon[1]-delta)+"\" "
chaine+="fill=\"none\" stroke=\""+couleur+"\" stroke-width=\""+epaisseur+"\" />"

# quel est l'encombrement du texte pour le centrer
a=indi[int(sosa[1])]
info=a.split("\n")
n=len(info)-1
j=0
hauteurtxt=-interligne2
while j<n:
    if info[j][0]=="@":# recherche nom
        hauteurtxt+=tailletitre1+interligne1
    elif (info[j][0]=="o")|(info[j][0]=="b"):# recherche naissance ou bapteme
        hauteurtxt+=tailletitre2+interligne2
    elif (info[j][0]=="+")|(info[j][0]=="%"):# recherche deces ou enterrement
        hauteurtxt+=tailletitre2+interligne2
    j+=1
# On écrit les info concernant l'individu 1

offset=yc-hauteurtxt/2
x1=xc-rayon[1]*0.75
x2=x1+rayon[1]*1.5
j=0
while j<n:
    if info[j][0]=="@":# recherche nom
        texte=info[j][1:len(info[j])-1]
        numcar=texte.index("/")
        texte=texte[numcar+1:len(texte)].upper()+" "+texte[0:numcar-1]
        texte=nettoietxt(texte) #transforme les caractères spéciaux pour XML

        offset+=tailletitre1
        chaine+="<line id=\"centre"+str(j)+"\" x1=\""+str(x1)+"\" y1=\""+str(offset)+"\" "
        chaine+="x2=\""+str(x2)+"\" y2=\""+str(offset)+"\" stroke-width=\"0\" />"
        chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre1))+"; fill:"+couleurtexte+"\">\n"
        chaine+="<textPath xlink:href=\"#centre"+str(j)+"\">"
        chaine+=texte
        chaine+="</textPath>\n</text>\n"
        offset=offset+interligne1        
    elif (info[j][0]=="o")|(info[j][0]=="b"):# recherche naissance ou bapteme
        texte=info[j]
        texte=nettoietxt(texte) #transforme les caractères spéciaux pour XML
        offset+=tailletitre2
        chaine+="<line id=\"centre"+str(j)+"\" x1=\""+str(x1)+"\" y1=\""+str(offset)+"\" "
        chaine+="x2=\""+str(x2)+"\" y2=\""+str(offset)+"\" stroke-width=\"0\" />"
        chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre2))+"; fill:"+couleurtexte+"\">\n"
        chaine+="<textPath xlink:href=\"#centre"+str(j)+"\">"
        chaine+=texte
        chaine+="</textPath>\n</text>\n"
        offset=offset+interligne2
    elif (info[j][0]=="+")|(info[j][0]=="%"):# recherche deces ou enterrement
        texte=info[j]
        texte=nettoietxt(texte)
        offset+=tailletitre2
        chaine+="<line id=\"centre"+str(j)+"\" x1=\""+str(x1)+"\" y1=\""+str(offset)+"\" "
        chaine+="x2=\""+str(x2)+"\" y2=\""+str(offset)+"\" stroke-width=\"0\" />"
        chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre2))+"; fill:"+couleurtexte+"\">\n"
        chaine+="<textPath xlink:href=\"#centre"+str(j)+"\">"
        chaine+=texte
        chaine+="</textPath>\n</text>\n"
        offset=offset+interligne2
    j+=1


# ============= CELLULES DES ANNEAUX CONCENTRIQUES ====================
i=2# numéro du sosa courant
while i <maxsosa:
    generation=int(math.log(i)/math.log(2))
    numroue=i-pow(2,generation)
    nbroue=pow(2,generation)

    angle1=2*math.pi*numroue/nbroue
    angle2=2*math.pi*((numroue+1)/nbroue)
    tracecell(rayon[generation],rayon[generation+1],angle1,angle2)

    #affiche de l'individu dans la cellule
    a=indi[int(sosa[i])]
    info=a.split("\n")
    n=len(info)-1
    #On calcule l'encombrement du texte en hauteur:
    #Est ce que ça tient dans la cellule, sinon, on rapetisse d'aun rapport "ratio"
    j=0
    hauteurtxt=interligne1+2*delta 
    while j<n:
        if info[j][0]=="@":# recherche nom
            hauteurtxt+=tailletitre1+interligne1
        elif (info[j][0]=="o")|(info[j][0]=="b"):# recherche naissance ou bapteme
            hauteurtxt+=tailletitre2+interligne2
        elif (info[j][0]=="+")|(info[j][0]=="%"):# recherche deces ou enterrement
            hauteurtxt+=tailletitre2+interligne2
        j+=1
    deltarayon=rayon[generation+1]-rayon[generation]-2*delta
    ratio=1
    offset=rayon[generation+1]-delta
    # Offset, c'est le décalage du texte par rapport au haut de la cellule

    if hauteurtxt>deltarayon:
        ratio=hauteurtxt/deltarayon
        offset=offset-interligne1*ratio
    else:
        offset=offset-interligne1-(deltarayon-hauteurtxt)/2

    # on reprend en ecrivant cette fois ci!
    j=0
    while j<n:
        if info[j][0]=="@":# recherche nom
            texte=info[j][1:len(info[j])-1]
            numcar=texte.index("/")
            texte=texte[numcar+1:len(texte)].upper()+" "+texte[0:numcar-1]
            texte=nettoietxt(texte) #transforme les caractères spéciaux pour XML

            offset=offset-tailletitre1*ratio
            deltaangle=2*delta/offset
            x1=xc-offset*math.cos(angle1+deltaangle)
            y1=yc-offset*math.sin(angle1+deltaangle)
            x2=xc-offset*math.cos(angle2-deltaangle)
            y2=yc-offset*math.sin(angle2-deltaangle)            
            arcercle(x1,y1,x2,y2,xc,yc,0)
            chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre1*ratio))+"; fill:"+couleurtexte+"\">\n"
            chaine+="<textPath xlink:href=\"#chem"+str(numchem)+"\">"
            chaine+=texte
            chaine+="</textPath>\n</text>\n"
            offset=offset-interligne1*ratio
            
        elif (info[j][0]=="o")|(info[j][0]=="b"):# recherche naissance ou bapteme
            texte=info[j]
            texte=nettoietxt(texte) #transforme les caractères spéciaux pour XML
            offset=offset-tailletitre2*ratio
            deltaangle=2*delta/offset
            x1=xc-offset*math.cos(angle1+deltaangle)
            y1=yc-offset*math.sin(angle1+deltaangle)
            x2=xc-offset*math.cos(angle2-deltaangle)
            y2=yc-offset*math.sin(angle2-deltaangle)            
            arcercle(x1,y1,x2,y2,xc,yc,0)
            chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre2*ratio))+"; fill:"+couleurtexte+"\">\n"
            chaine+="<textPath xlink:href=\"#chem"+str(numchem)+"\">"
            chaine+=texte
            chaine+="</textPath>\n</text>\n"
            offset=offset-interligne2*ratio
        elif (info[j][0]=="+")|(info[j][0]=="%"):# recherche deces ou enterrement
            texte=info[j]
            texte=nettoietxt(texte)
            offset=offset-tailletitre2*ratio
            deltaangle=2*delta/offset
            x1=xc-offset*math.cos(angle1+deltaangle)
            y1=yc-offset*math.sin(angle1+deltaangle)
            x2=xc-offset*math.cos(angle2-deltaangle)
            y2=yc-offset*math.sin(angle2-deltaangle)            
            arcercle(x1,y1,x2,y2,xc,yc,0)
            chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre2*ratio))+"; fill:"+couleurtexte+"\">\n"
            chaine+="<textPath xlink:href=\"#chem"+str(numchem)+"\">"
            chaine+=texte
            chaine+="</textPath>\n</text>\n"
            offset=offset-interligne2*ratio
        j+=1   
    i+=1
texte="Arbre dessiné par UncleDens : http://uncledens.chez-alice.fr/"
texte=nettoietxt(texte)
x1=2
x2=2*xc
y1=2*yc-2
chaine+="<line id=\"signature\" x1=\""+str(x1)+"\" y1=\""+str(y1)+"\" "
chaine+="x2=\""+str(x2)+"\" y2=\""+str(y1)+"\" stroke-width=\"0\" />"
chaine+="<text style=\"font-family:"+police+"; font-size:"+str(int(tailletitre1/3))+"; fill:grey\">\n"
chaine+="<textPath xlink:href=\"#signature\">"
chaine+=texte
chaine+="</textPath>\n</text>\n" 

chaine+="\n</svg>"
destination.write(chaine)
destination.close()
print("L\'arbre a correctement été généré et s\'appelle \"arbre_circ.svg\"")
print("Vous pouvez désormais l\'ouvrir avec votre logiciel \"Inkscape\" que vous pouvez télécharger ici :\n")
print("http://www.clubic.com/telecharger-fiche14363-inkscape.html")
print("Ce logiciel est lire et gratuit et permet d\'enregistrer votre arbre au format \"PDF\" pour l\'impression.")

